aboutsummaryrefslogtreecommitdiffstats
path: root/coin/provisioning/common/unix/DownloadURL.sh
diff options
context:
space:
mode:
Diffstat (limited to 'coin/provisioning/common/unix/DownloadURL.sh')
-rwxr-xr-xcoin/provisioning/common/unix/DownloadURL.sh100
1 files changed, 44 insertions, 56 deletions
diff --git a/coin/provisioning/common/unix/DownloadURL.sh b/coin/provisioning/common/unix/DownloadURL.sh
index 0579451f..c1c27cbb 100755
--- a/coin/provisioning/common/unix/DownloadURL.sh
+++ b/coin/provisioning/common/unix/DownloadURL.sh
@@ -1,37 +1,6 @@
-#!/bin/sh
-
-#############################################################################
-##
-## Copyright (C) 2019 The Qt Company Ltd.
-## Contact: http://www.qt.io/licensing/
-##
-## This file is part of the provisioning scripts of the Qt Toolkit.
-##
-## $QT_BEGIN_LICENSE:LGPL21$
-## Commercial License Usage
-## Licensees holding valid commercial Qt licenses may use this file in
-## accordance with the commercial license agreement provided with the
-## Software or, alternatively, in accordance with the terms contained in
-## a written agreement between you and The Qt Company. For licensing terms
-## and conditions see http://www.qt.io/terms-conditions. For further
-## information use the contact form at http://www.qt.io/contact-us.
-##
-## GNU Lesser General Public License Usage
-## Alternatively, this file may be used under the terms of the GNU Lesser
-## General Public License version 2.1 or version 3 as published by the Free
-## Software Foundation and appearing in the file LICENSE.LGPLv21 and
-## LICENSE.LGPLv3 included in the packaging of this file. Please review the
-## following information to ensure the GNU Lesser General Public License
-## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
-## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
-##
-## As a special exception, The Qt Company gives you certain additional
-## rights. These rights are described in The Qt Company LGPL Exception
-## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
-##
-## $QT_END_LICENSE$
-##
-#############################################################################
+#!/bin/bash
+# Copyright (C) 2019 The Qt Company Ltd.
+# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
# A helper script used for downloading a file from a URL or an alternative
@@ -39,10 +8,12 @@
# based on the SHA length). Target filename should also be given.
############################ BOILERPLATE ###############################
-command -v sha1sum >/dev/null || alias sha1sum='shasum -a 1'
-command -v sha256sum >/dev/null || alias sha256sum='shasum -a 256'
-command -v sha384sum >/dev/null || alias sha384sum='shasum -a 384'
-command -v sha512sum >/dev/null || alias sha512sum='shasum -a 512'
+
+command -v sha1sum >/dev/null || sha1sum () { shasum -a 1 "$@" ; }
+command -v sha256sum >/dev/null || sha256sum () { shasum -a 256 "$@" ; }
+command -v sha384sum >/dev/null || sha384sum () { shasum -a 384 "$@" ; }
+command -v sha512sum >/dev/null || sha512sum () { shasum -a 512 "$@" ; }
+
########################################################################
@@ -50,9 +21,12 @@ Download () {
url="$1"
targetFile="$2"
- command -v curl >/dev/null \
- && curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url" \
- || wget --tries 5 -O "$targetFile" "$url"
+ if command -v curl >/dev/null
+ then
+ curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url"
+ else
+ wget --tries 5 -O "$targetFile" "$url"
+ fi
}
VerifyHash () {
@@ -73,10 +47,10 @@ VerifyHash () {
65) sha256sum "$file" ;;
97) sha384sum "$file" ;;
129) sha512sum "$file" ;;
- *) echo "FATAL! Unknown hash length: $hashLength" 1>&2 && exit 1 ;;
+ *) echo "FATAL! Unknown hash length: $hashLength" 1>&2 ;;
esac | cut -d ' ' -f 1`
- if [ ! "$expectedHash" = "$hash" ]
+ if [ -z $hash ] || [ ! "$expectedHash" = "$hash" ]
then
echo "FAIL! wrong file hash: $file $hash" 1>&2
return 1
@@ -89,22 +63,36 @@ DownloadURL () {
url=$1
url2=$2
expectedHash=$3
- targetFile=$4
-
- if VerifyHash "$targetFile" "$expectedHash"
+ # Optional argument $4: destination filename
+ if [ -z "$4" ]
then
- echo "Skipping download, found and validated existing file: $targetFile"
+ # defaults to the last component of $url
+ targetFile="${url/*\//}"
else
- echo "Downloading from primary URL: $url"
- if ! Download "$url" "$targetFile"
+ targetFile=$4
+ fi
+
+ # If a non-empty file already exists
+ if [ -s "$targetFile" ]
+ then
+ if VerifyHash "$targetFile" "$expectedHash"
+ then
+ echo "Skipping download, found and validated existing file: $targetFile"
+ return
+ else
+ echo "WARNING: Non-empty but different file found at destination; will re-download and overwrite file: $targetFile"
+ fi
+ fi
+
+ echo "Downloading from primary URL: $url"
+ if ! Download "$url" "$targetFile"
+ then
+ echo "FAIL! to download, trying alternative URL: $url2" 1>&2
+ if ! Download "$url2" "$targetFile"
then
- echo "FAIL! to download, trying alternative URL: $url2" 1>&2
- if ! Download "$url" "$targetFile"
- then
- echo 'FAIL! to download even from alternative url' 1>&2
- return 1
- fi
+ echo 'FAIL! to download even from alternative URL' 1>&2
+ return 1
fi
- VerifyHash "$targetFile" "$expectedHash"
fi
+ VerifyHash "$targetFile" "$expectedHash"
}